#include "paco_thread.h"

extern "C" {
#include <Padico/PM2.h>
}

class paco_marcel_mutex; // forward declaration

class paco_marcel_condition : public paco_condition
{
 public:
  paco_marcel_condition(paco_marcel_mutex* m);
  ~paco_marcel_condition();

  void wait();
  void signal();

 private:
  marcel_cond_t condition;
  paco_marcel_mutex * mutex;
};


class paco_marcel_mutex : public paco_mutex
{

public:
  paco_marcel_mutex();
  ~paco_marcel_mutex();
  
  void lock();
  void unlock();

private:
  marcel_mutex_t mutex;

  friend void paco_marcel_condition::wait();
};

class paco_marcel_fabrique : virtual public paco_fabrique_thread {

public:
  paco_mutex* paco_create_mutex();
  paco_condition* paco_create_condition(paco_mutex * mutex);
  // Create a joinable thread
  paco_thread * paco_create_thread(void* (*fn)(void*), void* arg = NULL);
  // Create a detach thread
  paco_thread * paco_create_thread(void (*fn)(void*), void* arg = NULL);
};

class paco_marcel_thread : public paco_thread
{
public:
  paco_marcel_thread();
  virtual ~paco_marcel_thread();
  
private:
  marcel_t thread;

  friend paco_thread * paco_marcel_fabrique::paco_create_thread(void* (*fn)(void*), void* arg = NULL);
  friend paco_thread * paco_marcel_fabrique::paco_create_thread(void (*fn)(void*), void* arg = NULL);
};
